package com.fr.plugins.dsgroup;


import com.fr.base.TableData;
import com.fr.base.TableDataBean;
import com.fr.config.RemoteConfigEvent;
import com.fr.config.utils.UniqueKey;
import com.fr.design.DesignModelAdapter;

import com.fr.design.data.DesignTableDataManager;
import com.fr.design.data.datapane.TableDataSourceOP;
import com.fr.design.data.datapane.TableDataTree;
import com.fr.design.editlock.EditLockUtils;
import com.fr.event.EventDispatcher;
import com.fr.file.*;
import com.fr.general.NameObject;
import com.fr.design.data.tabledata.wrapper.TableDataWrapper;
import com.fr.design.gui.itree.refreshabletree.ExpandMutableTreeNode;
import com.fr.log.FineLoggerFactory;
import com.fr.plugins.dsgroup.fun.DSGroupTableData;
import com.fr.plugins.dsgroup.rpc.GroupTableDataOperator;
import com.fr.report.LockItem;
import com.fr.stable.StringUtils;
import com.fr.workspace.WorkContext;
import javax.swing.tree.*;
import java.util.*;
import java.util.List;

/**
 * Created by phetran_ye on 2018/8/12.
 * 都是继承TableDataTree，没有多态
 */
public class GroupTableDataTree extends TableDataTree {
    private static final long serialVersionUID = 1L;

    public static final int TABLE_DATA_SET_INITIAL_SIZE=4;

    private final int TEMPLATE_TABLE_DATA=0;
    private final int SERVER_TABLE_DATA=1;

    private TableDataAware pane;
    public void setPane(TableDataAware p){
        this.pane=p;
    }
    /**
     * Constructor.
     */

    // CellRenderer
    /*
    该属性会在父类构造方法里完成实例化
    private DefaultTreeCellRenderer tableDataTreeCellRenderer = new DefaultTreeCellRenderer() {
        private static final long serialVersionUID = 1L;

        @Override
        public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
            super.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row, hasFocus);
            ExpandMutableTreeNode treeNode = (ExpandMutableTreeNode) value;
            Object userObj = treeNode.getUserObject();
            if (userObj instanceof String) {
                // p:这个是column field.
                this.setIcon(BaseUtils.readIcon("com/fr/design/images/data/field.png"));
                this.setText((String) userObj);
            } else if (userObj instanceof NameObject) {
                NameObject nameObject = (NameObject) userObj;
                this.setText(nameObject.getName());
                if (nameObject.getObject() instanceof TableDataWrapper) {
                    TableDataWrapper tableDataWrappe = (TableDataWrapper) nameObject.getObject();
                    this.setIcon(tableDataWrappe.getIcon());
                } else if (nameObject.getObject() instanceof Integer) {
                    int num = (Integer) nameObject.getObject();
                    if (num == TableDataSourceOP.SERVER_TABLE_DATA) {
                        this.setIcon(BaseUtils.readIcon(IconPathConstants.STD_SHOW_ICON_PATH));
                    } else if (num == TableDataSourceOP.STORE_PRECEDURE_DATA) {
                        this.setIcon(BaseUtils.readIcon(IconPathConstants.SP_SHOW_ICON_PATH));
                    } else {
                        this.setIcon(BaseUtils.readIcon(IconPathConstants.DS_QUERY_ICON_PATH));
                    }
                } else {
                    this.setIcon(BaseUtils.readIcon("/com/fr/design/images/data/store_procedure.png"));
                }
            } else if (userObj == PENDING) {
                this.setIcon(null);
                this.setText(PENDING.toString());
            }
            *//*
            11版本设计器更新220325
            // 这里新建一个Label作为render是因为JTree在动态刷新的时候，节点上render画布的的宽度不会变，会使得一部分比较长的数据显示为"..."
            UILabel label = new UILabel();
            label.setText(getText());
            label.setIcon(getIcon());
            Dimension dim = label.getPreferredSize();
            dim.height += 2;
            this.setSize(dim);
            this.setPreferredSize(dim);*//*
            this.setB
            this.setBackgroundNonSelectionColor(UIConstants.TREE_BACKGROUND);
            this.setTextSelectionColor(Color.WHITE);
            this.setBackgroundSelectionColor(UIConstants.FLESH_BLUE);
            return this;
        }
    };

    public DefaultTreeCellRenderer getTableDataTreeCellRenderer() {
        return tableDataTreeCellRenderer;
    }

    public void setTableDataTreeCellRenderer(DefaultTreeCellRenderer tableDataTreeCellRenderer) {
        this.tableDataTreeCellRenderer = tableDataTreeCellRenderer;
    }*/

    /*
    删除220325
    @Override
    protected void refreshTreeNode(ExpandMutableTreeNode eTreeNode, String childName) {
        if (interceptRefresh(eTreeNode)) {
            return;
        }
        boolean refreshall = childName.isEmpty();
        ExpandMutableTreeNode[] new_nodes = loadChildTreeNodes(eTreeNode);

        List<DefaultMutableTreeNode> childTreeNodeList = new ArrayList<>();
        for (int i = 0, len = eTreeNode.getChildCount(); i < len; i++) {
            if (eTreeNode.getChildAt(i) instanceof ExpandMutableTreeNode) {
                childTreeNodeList.add((ExpandMutableTreeNode) eTreeNode.getChildAt(i));
            } else {
                childTreeNodeList.add((DefaultMutableTreeNode) eTreeNode.getChildAt(i));
            }
        }

        eTreeNode.removeAllChildren();

        for (int ci = 0; ci < new_nodes.length; ci++) {
            Object cUserObject = new_nodes[ci].getUserObject();
            ExpandMutableTreeNode cTreeNode = null;
            for (int ni = 0, nlen = childTreeNodeList.size(); ni < nlen; ni++) {
                cTreeNode = (ExpandMutableTreeNode) childTreeNodeList.get(ni);
                if (ComparatorUtils.equals(cTreeNode.getUserObject(), cUserObject)) {
                    if (!refreshall && !ComparatorUtils.equals(childName, ((NameObject) cUserObject).getName())) {
                        new_nodes[ci] = cTreeNode;
                        break;
                    }
                    new_nodes[ci].setExpanded(cTreeNode.isExpanded());
                    if (cTreeNode.getChildCount()>0 && cTreeNode.getFirstChild() instanceof ExpandMutableTreeNode && cTreeNode.isExpanded()) {
                        checkChildNodes(cTreeNode, new_nodes[ci]);
                    }
                    break;
                }
            }

            //eTreeNode.add(new_nodes[ci]);
        }
        loadTreeNode(eTreeNode);
    }*/


    /*
     * p:获得选中的NameObject = name + tabledata.
     */
    @Override
    public NameObject getSelectedNameObject() {
        TreePath selectedTreePath = this.getSelectionPath();
        if (selectedTreePath == null) {
            return null;
        }
        ExpandMutableTreeNode selectedTreeNode = (ExpandMutableTreeNode) selectedTreePath.getLastPathComponent();
        Object selectedUserObject = selectedTreeNode.getUserObject();
        ExpandMutableTreeNode parentTreeNode = (ExpandMutableTreeNode) selectedTreeNode.getParent();
        if(isGroupData(parentTreeNode)){
            return (NameObject) selectedUserObject;
        }
        Object parentUserObject = parentTreeNode.getUserObject();
        if (parentUserObject instanceof NameObject && ((NameObject) parentUserObject).getObject() instanceof Integer) {
            if (selectedUserObject instanceof NameObject) {
                return (NameObject) selectedUserObject;
            }
        } else {
            parentTreeNode = (ExpandMutableTreeNode) selectedTreeNode.getParent();
            parentUserObject = parentTreeNode.getUserObject();

            if (parentUserObject != null) {
                if (!(parentUserObject instanceof NameObject))  {
                    return (NameObject) selectedUserObject;
                }
                /*//分组数据集下的子节点返回自身
                else if(isGroupData(selectedTreeNode)){
                    return (NameObject) selectedUserObject;
                }*/
                else {
                    return (NameObject) parentUserObject;
                }
            }
        }
        return null;

    }

    /*
    待验证能否删除
    public TableDataWrapper[] getSelectedDatas() {
        TreePath[] selectedTreePaths = this.getSelectionPaths();
        if (selectedTreePaths == null || selectedTreePaths.length == 0) {
            return null;
        }
        TableDataWrapper[] nameobjs = new TableDataWrapper[selectedTreePaths.length];
        for (int i = 0; i < selectedTreePaths.length; i++) {
            TreePath selectedTreePath = selectedTreePaths[i];
            ExpandMutableTreeNode selectedTreeNode = (ExpandMutableTreeNode) selectedTreePath.getLastPathComponent();
            Object selectedUserObject = selectedTreeNode.getUserObject();
            ExpandMutableTreeNode parentTreeNode = (ExpandMutableTreeNode) selectedTreeNode.getParent();
            Object parentUserObject = parentTreeNode.getUserObject();
            if (parentUserObject instanceof NameObject && ((NameObject) parentUserObject).getObject() instanceof Integer) {
                if (selectedUserObject instanceof NameObject) {
                    Object obj = ((NameObject) selectedUserObject).getObject();
                    if (obj instanceof TableDataWrapper) {
                        nameobjs[i] = (TableDataWrapper) obj;
                    }
                }
            } else {
                return new TableDataWrapper[0];
            }
        }

        return nameobjs;
    }*/

    //删除待验证
    /*public NameObject getRealSelectedNameObject() {
        TreePath selectedTreePath = this.getSelectionPath();
        if (selectedTreePath == null) {
            return null;
        }

        ExpandMutableTreeNode selectedTreeNode = (ExpandMutableTreeNode) selectedTreePath.getLastPathComponent();
        Object selectedUserObject = selectedTreeNode.getUserObject();
        if (selectedUserObject instanceof NameObject) {
            return (NameObject) selectedUserObject;
        }

        selectedTreeNode = (ExpandMutableTreeNode) selectedTreeNode.getParent();
        selectedUserObject = selectedTreeNode.getUserObject();
        if (selectedUserObject instanceof NameObject) {
            return (NameObject) selectedUserObject;
        }
        return null;
    }*/

    /**
     * p:添加一个NameObject节点.
     */
    //删除待验证
    /*public void addNameObject(NameObject no) {
        if (no == null) {
            return;
        }
        DefaultTreeModel treeModel = (DefaultTreeModel) this.getModel();

        // 新建一个放着NameObject的newChildTreeNode,加到Root下面
        ExpandMutableTreeNode root = (ExpandMutableTreeNode) treeModel.getRoot();

        ExpandMutableTreeNode newChildTreeNode = new ExpandMutableTreeNode(no);
        root.add(newChildTreeNode);
        newChildTreeNode.add(new ExpandMutableTreeNode());

        treeModel.reload(root);
    }*/

    /**
     * 覆盖方法，如果是根节点，返回根节点直接下级节点而不是父类的所有节点
     * @param node
     * @return
     */
    @Override
    protected ExpandMutableTreeNode[] loadChildTreeNodes(ExpandMutableTreeNode node) {
        DefaultTreeModel treeModel = (DefaultTreeModel) this.getModel();
        ExpandMutableTreeNode root = (ExpandMutableTreeNode) treeModel.getRoot();
        if(root.equals(node)){
            return this.loadChildNodesOfRoot(node);
        }else{
            if(isGroupData(node)){
                DSGroupTableData ds=this.getGroupData(node);
                if(!ds.hasChildren()){
                    return new ExpandMutableTreeNode[0];
                }
                ExpandMutableTreeNode[] allNodes=super.loadChildTreeNodes(root);
                Map<String,ExpandMutableTreeNode> allNodesMap=new HashMap<>(TABLE_DATA_SET_INITIAL_SIZE);
                for(ExpandMutableTreeNode nd:allNodes){
                    allNodesMap.put(this.getDSName(nd),nd);
                }
                this.loadDSGroupTreeNode(node,allNodesMap,allNodesMap);
                ExpandMutableTreeNode[] childNodes=new ExpandMutableTreeNode[node.getChildCount()];
                for(int i=0;i<node.getChildCount();i++){
                    childNodes[i]=(ExpandMutableTreeNode) node.getChildAt(i);
                }
                return childNodes;
            }else{
                return super.loadChildTreeNodes(node);
            }
        }

    }

    /**
     * 加载根节点直接下级节点
     * @param root
     * @return
     */
    private ExpandMutableTreeNode[] loadChildNodesOfRoot(ExpandMutableTreeNode root){
        Map<String,ExpandMutableTreeNode> allNodesMap=new HashMap<>(TABLE_DATA_SET_INITIAL_SIZE);
        Map<String,ExpandMutableTreeNode> rootChildrenMap=new HashMap<>(TABLE_DATA_SET_INITIAL_SIZE);
        ExpandMutableTreeNode[] children = super.loadChildTreeNodes(root);
        for(ExpandMutableTreeNode etn:children){
            allNodesMap.put(this.getDSName(etn),etn);
            rootChildrenMap.put(getDSName(etn),etn);
        }
        for(ExpandMutableTreeNode etn:children){
            if(!rootChildrenMap.containsKey(this.getDSName(etn))){
                continue;
            }
            if(isGroupData(etn)){
                //去掉"正在加载"
                if(((ExpandMutableTreeNode)etn.getFirstChild()).getUserObject() == PENDING){
                    etn.remove(0);
                }
                if(getGroupData(etn).hasChildren()){
                    loadDSGroupTreeNode(etn, allNodesMap,rootChildrenMap);
                }

            }
        }
        if(rootChildrenMap.isEmpty()){
            return new ExpandMutableTreeNode[0];
        }else{
            ExpandMutableTreeNode[] result=new ExpandMutableTreeNode[rootChildrenMap.size()];
            return rootChildrenMap.values().toArray(result);
        }
    }

    public String getDSName(ExpandMutableTreeNode tn){
        return ((NameObject)tn.getUserObject()).getName();
    }

    public TableData getTableData(ExpandMutableTreeNode tn){
        return ((TableDataWrapper) ((NameObject)tn.getUserObject()).getObject()).getTableData();
    }

    public DSGroupTableData getGroupData(ExpandMutableTreeNode tn){
        return (DSGroupTableData)((TableDataWrapper) ((NameObject)tn.getUserObject()).getObject()).getTableData();
    }

    public static boolean isGroupData(ExpandMutableTreeNode tn){
        if(null==tn) {
            return false;
        }
        if(!(tn.getUserObject() instanceof NameObject)){
            return false;
        }
        return ((TableDataWrapper) ((NameObject)tn.getUserObject()).getObject()).getTableData() instanceof DSGroupTableData;
    }

    public static boolean nodeIsTableData(ExpandMutableTreeNode node){
        return (node.getUserObject() instanceof NameObject) && (
                ((NameObject)node.getUserObject()).getObject() instanceof TableDataWrapper
        );
    }

    private void loadDSGroupTreeNode(ExpandMutableTreeNode groupNode,Map<String,ExpandMutableTreeNode> nodes,Map<String,ExpandMutableTreeNode> leftNodes){
        DSGroupTableData ds=this.getGroupData(groupNode);
        if(!ds.hasChildren()){
            return;
        }
        if(groupNode.getChildCount()>0){
            groupNode.removeAllChildren();
        }
        String[] nodeNames=ds.getChildrenDSNames().split(DSGroupTableData.getSeparator());
        //groupNode.removeAllChildren();
        //有父类的且有效的进行移除，最后不显示
        if(ds.hasParent()){
            //检查parent数据是否有效
            boolean validParent=true;
            String parentDSName=ds.getParentDSName();
            if(!nodes.containsKey(parentDSName)){
                validParent=false;
            }else{
                ExpandMutableTreeNode parentNode=nodes.get(parentDSName);
                if(!isGroupData(parentNode)){
                    validParent=false;
                }else{
                    validParent=getGroupData(parentNode).hasChild(ds.getName());
                }
            }

            //有效的parent数据才会移除
            if(validParent){
                leftNodes.remove(ds.getName());
            }
        }

        for(int i=0;i<nodeNames.length;i++){
            ExpandMutableTreeNode node=nodes.get(nodeNames[i]);
            if(node==null){
                continue;
            }
            if(isGroupData(node)){
                //去掉"正在加载"
                /*if(((ExpandMutableTreeNode)node.getFirstChild()).getUserObject() == PENDING){
                    node.remove(0);
                }*/
                loadDSGroupTreeNode(node, nodes, leftNodes);
            }
            groupNode.add(node);
            leftNodes.remove(nodeNames[i]);
        }
    }

    public void moveToGroup(ExpandMutableTreeNode groupToMoveTo){
        TableDataSourceOP op=pane.getOp();
        if (op==null) {
            return;
        }
        boolean global=false;
        if(op.getDataMode()==SERVER_TABLE_DATA){
            global=true;
        }
        TreePath[] paths=getSelectionPaths();
        //待分组的节点的父节点，用于展开
        Set<ExpandMutableTreeNode> parentNodes=new HashSet<>();
        List<ExpandMutableTreeNode> nodesToMove=new ArrayList<>();
        ExpandMutableTreeNode root=(ExpandMutableTreeNode)(this.getModel()).getRoot();
        Map<String,TableData> changedGroupTableDataMap=null;
        if(global){
            changedGroupTableDataMap=new HashMap<>(TABLE_DATA_SET_INITIAL_SIZE);
        }
        //将选择的节点拼成子节点数据,以防止选择了分组又选择了其下的数据集
        for(int i=0;i<paths.length;i++){
            if(!(paths[i].getLastPathComponent() instanceof ExpandMutableTreeNode)){
                continue;
            }
            ExpandMutableTreeNode tn=(ExpandMutableTreeNode) paths[i].getLastPathComponent();
            if(!nodeIsTableData(tn)){
                continue;
            }
            //分组本身
            if(tn.equals(groupToMoveTo)){
                continue;
            }
            nodesToMove.add(tn);
            ExpandMutableTreeNode parent=getDsGroupParentNodeIfExists(tn);
            if(parent!=null){
                //clear
                this.clearNodeTableDataNameSpace(parent);
                this.moveNodeOutOfParent(parent,tn);
                if(global){
                    changedGroupTableDataMap.put(this.getDSName(parent),this.getGroupData(parent));
                }
                parentNodes.add(parent);
            }
            groupToMoveTo.add(tn);

        }
        if(nodesToMove.size()==0){
            return;
        }
        //clear
        this.clearNodeTableDataNameSpace(groupToMoveTo);
        DSGroupTableData groupData=this.getGroupData(groupToMoveTo);
        for(ExpandMutableTreeNode nodeToMove:nodesToMove){
            //待分组的节点是分组
            if(isGroupData(nodeToMove)){
                //clear
                this.clearNodeTableDataNameSpace(nodeToMove);
                getGroupData(nodeToMove).setParentDSName(getDSName(groupToMoveTo));
                if(global){
                    changedGroupTableDataMap.put(this.getDSName(nodeToMove),this.getGroupData(nodeToMove));
                }
            }
            //选中的节点是该分组下的节点
            if(groupData.hasChild(getDSName(nodeToMove))) {
                continue;
            }
            groupData.addChildren(getDSName(nodeToMove));
        }
        if(global){
            changedGroupTableDataMap.put(this.getDSName(groupToMoveTo),this.getGroupData(groupToMoveTo));
        }
        if(global){
            onGlobalDsGroupChanged(changedGroupTableDataMap);
        }else{
            onTemplateDsGroupChanged();
        }
        parentNodes.add(groupToMoveTo);
        ((DefaultTreeModel)this.getModel()).reload(root);
        for(ExpandMutableTreeNode node:parentNodes){
            this.expandNodesUpwardRecursively(node,root);
        }

    }

    private void expandNodesUpwardRecursively(ExpandMutableTreeNode node,ExpandMutableTreeNode root){
        node.setExpanded(true);
        node.expandCurrentTreeNode(this);
        TreeNode parent=node.getParent();
        if(parent!=null&&!parent.equals(root)&&(parent instanceof ExpandMutableTreeNode)){
            expandNodesUpwardRecursively((ExpandMutableTreeNode) parent,root);
        }
    }

    public void moveToRoot(){
        TableDataSourceOP op=pane.getOp();
        if (op==null) {
            return;
        }
        boolean global=false;
        if(op.getDataMode()==SERVER_TABLE_DATA){
            global=true;
        }
        TreePath[] paths=getSelectionPaths();
        Map<String,TableData> changedDsGroupTableDatas=null;
        if(global){
            changedDsGroupTableDatas=new HashMap<>(TABLE_DATA_SET_INITIAL_SIZE);
        }
        //待分组的节点的父节点，用于展开
        Set<ExpandMutableTreeNode> parentNodes=new HashSet<>();
        ExpandMutableTreeNode root=(ExpandMutableTreeNode)(this.getModel()).getRoot();
        int nodeToMoveCnt=0;
        for(int i=0;i<paths.length;i++){
            if(!(paths[i].getLastPathComponent() instanceof ExpandMutableTreeNode)){
                continue;
            }
            ExpandMutableTreeNode tn=(ExpandMutableTreeNode) paths[i].getLastPathComponent();
            if(!nodeIsTableData(tn)){
                continue;
            }
            nodeToMoveCnt++;
            ExpandMutableTreeNode parent=getDsGroupParentNodeIfExists(tn);
            if(parent!=null){
                //clear
                this.clearNodeTableDataNameSpace(parent);
                this.moveNodeOutOfParent(parent,tn);
                if(global){
                    changedDsGroupTableDatas.put(this.getDSName(parent),this.getGroupData(parent));
                }
                parentNodes.add(parent);
            }
            root.add(tn);
            if(isGroupData(tn)){
                //clear
                this.clearNodeTableDataNameSpace(tn);
                getGroupData(tn).setParentDSName(null);
                if(global){
                    changedDsGroupTableDatas.put(getDSName(tn),getTableData(tn));
                }
            }
        }
        if(nodeToMoveCnt==0){
            return;
        }
        if(global){
            onGlobalDsGroupChanged(changedDsGroupTableDatas);
        }else{
            onTemplateDsGroupChanged();
        }
        ((DefaultTreeModel)this.getModel()).reload(root);
        for(ExpandMutableTreeNode node:parentNodes){
            this.expandNodesUpwardRecursively(node,root);
        }
    }

    private void clearNodeTableDataNameSpace(ExpandMutableTreeNode tn){
        ((UniqueKey)((TableDataWrapper) ((NameObject)tn.getUserObject()).getObject()).getTableData()).setNameSpace(null);
    }

    /**
     * 模板数据集分组修改事件响应
     */
    private void onTemplateDsGroupChanged(){
        pane.getTC().fireTargetModified();
    }

    /**
     * 服务器数据集分组修改事件响应
     */
    private void onGlobalDsGroupChanged(Map<String,TableData> changedGroupTableDataMap){
        //参照GlobalTableDataAction actionPerform （弹出服务器数据集编辑面板，点确认后保存）
        boolean lock = EditLockUtils.lock(LockItem.SERVER_TABLE_DATA);
        //!LOCK
        if (!lock) {
            EditLockUtils.showLockMessage();
        }else{
            Map<String,TableData> tableDatas=TableDataConfig.getInstance().getTableDatas();

            //Nameable[] originalDS =new Nameable[tableDataMap.size()];
            List<TableDataBean> newTDBeans = new ArrayList<>();
            //貌似没用
            //List<String> tdNames=new ArrayList<>();
            /*for(Map.Entry<String,TableData> entry:tableDatas.entrySet()){
                String name=((NameObject)node.getUserObject()).getName();
                tdNames.add(name);
                TableData tableData=((TableDataWrapper) ((NameObject)node.getUserObject()).getObject()).getTableData();
                ((UniqueKey)tableData).setNameSpace(null);
                newTDBeans.add(new TableDataBean(name,StringUtils.EMPTY,tableData));
            }*/
            for(Map.Entry<String,TableData> entry:tableDatas.entrySet()){
                String name=entry.getKey();
                newTDBeans.add(new TableDataBean(name,StringUtils.EMPTY,
                        changedGroupTableDataMap.containsKey(name)? changedGroupTableDataMap.get(name) :entry.getValue()
                ));
            }
            //changedDsGroupTableDatas.clear();
            try {
                WorkContext.getCurrent().get(GroupTableDataOperator.class).saveTableData(Collections.emptyList(),newTDBeans);//new ArrayList<>(tableDataMap.keySet())
                if (!WorkContext.getCurrent().isLocal()) {
                    EventDispatcher.fire(RemoteConfigEvent.EDIT, TableDataConfig.getInstance().getNameSpace());
                }
            } catch (Exception e) {
                FineLoggerFactory.getLogger().error(e.getMessage(), e);
            }
            DesignTableDataManager.clearGlobalDs();
            //貌似沒用待验证
            /*Iterator tdIterator = tdNames.iterator();

            while(tdIterator.hasNext()) {
                String var2 = (String)tdIterator.next();
                DesignTableDataManager.removeSelectedColumnNames(var2);
            }*/
            GroupTableDataTreePane.getInstance(DesignModelAdapter.getCurrentModelAdapter());
            DesignTableDataManager.fireDSChanged(new HashMap<>());
            EditLockUtils.unlock(LockItem.SERVER_TABLE_DATA);
        }
    }


    //从节点的父节点移除节点，如果父节点是分组还要修改分组数据集数据
    public void moveNodeOutOfParent(ExpandMutableTreeNode parent, ExpandMutableTreeNode nodeToMove){
        parent.remove(nodeToMove);
        if(isGroupData(parent)){
            this.getGroupData(parent).removeChild(this.getDSName(nodeToMove));
        }
    }

    /**
     * 删除一个数据集节点
     * @param nodeToRemove
     */
    public void removeNode(ExpandMutableTreeNode nodeToRemove){
        ExpandMutableTreeNode parent=this.getDsGroupParentNodeIfExists(nodeToRemove);
        if(parent==null){
            //无上级分组并且本身是分组
            if(isGroupData(nodeToRemove)){
                for(int i=0;i<nodeToRemove.getChildCount();i++){
                    ExpandMutableTreeNode child=(ExpandMutableTreeNode) nodeToRemove.getChildAt(i);
                    if(isGroupData(child)){
                        this.getGroupData(child).setParentDSName(null);
                    }
                }
            }
            this.refresh();
            this.requestFocus();
            this.setSelectionRow(this.getRowCount() - 1);
        }else{
            //有上级分组

            if(isGroupData(nodeToRemove)){
                for(int i=0;i<nodeToRemove.getChildCount();i++){
                    ExpandMutableTreeNode child=(ExpandMutableTreeNode) nodeToRemove.getChildAt(i);
                    if(isGroupData(child)){
                        this.getGroupData(child).setParentDSName(this.getDSName(parent));
                    }
                }
                getGroupData(parent).changeChildName(this.getDSName(nodeToRemove),getGroupData(nodeToRemove).getChildrenDSNames());
            }else{
                getGroupData(parent).removeChild(this.getDSName(nodeToRemove));
            }
            this.refreshGroupNode(parent);
        }

    }

    //更新了某个节点名称
    public void updateTableDataNodeName(String oldName,String newName){
        ExpandMutableTreeNode tableDataNode=this.getRealSelectedTableDataNode();
        ExpandMutableTreeNode parent=getDsGroupParentNodeIfExists(tableDataNode);
        //如果有上级分组
        if(parent!=null){
            getGroupData(parent).changeChildName(oldName,newName);
        }

        //如果有下级分组
        for(int i=0;i<tableDataNode.getChildCount();i++){
            TreeNode cn=tableDataNode.getChildAt(i);
            if(cn instanceof ExpandMutableTreeNode){
                ExpandMutableTreeNode child=(ExpandMutableTreeNode) cn;
                if(isGroupData(child)){
                    this.getGroupData(child).setParentDSName(newName);
                }
            }
        }
        this.refreshParent(this.getSelectionPath());

    }

    /**
     * 将一个数据集添加到分组，待添加的包括分组数据集
     * @param group
     * @param tdName
     */
    public void addTableDataToGroup(ExpandMutableTreeNode group,String tdName){
        DSGroupTableData groupData=getGroupData(group);
        String children=groupData.getChildrenDSNames();
        children= children==null? tdName : (children+DSGroupTableData.getSeparator()+tdName) ;
        groupData.setChildrenDSNames(children);
        this.refreshGroupNode(group);
    }

    /**
     * 分组下的数据集修改后刷新分组节点
     * @param group
     */
    public void refreshGroupNode(ExpandMutableTreeNode group){
        this.refreshTreeNode(group,StringUtils.EMPTY);
        ((DefaultTreeModel)this.getModel()).reload(group);
        if(!group.isExpanded()){
            group.setExpanded(true);
        }
        group.expandCurrentTreeNode(this);
    }

    /**
     * 防止分组下添加数据集的时候不刷新
     * @param node
     * @return
     */
    @Override
    protected boolean interceptRefresh(ExpandMutableTreeNode node) {
        if(isGroupData(node)&&getGroupData(node).hasChildren()){
            return false;
        }else{
            return super.interceptRefresh(node);
        }
    }

    public ExpandMutableTreeNode getDsGroupParentNodeIfExists(ExpandMutableTreeNode node){
        TreeNode pnode=node.getParent();
        if(pnode instanceof ExpandMutableTreeNode){
            ExpandMutableTreeNode parent=(ExpandMutableTreeNode) pnode;
            if(isGroupData(parent)){
                return parent;
            }
        }
        return null;
    }

    /**
     * 获取实际选择的数据集节点
     * @return
     */
    public ExpandMutableTreeNode getRealSelectedTableDataNode() {
        TreePath selectedPath = this.getSelectionPath();
        if (selectedPath == null) {
            return null;
        } else {
            ExpandMutableTreeNode selectedNode = (ExpandMutableTreeNode)selectedPath.getLastPathComponent();
            Object object = selectedNode.getUserObject();
            if (object instanceof NameObject) {
                return selectedNode;
            } else {
                selectedNode = (ExpandMutableTreeNode)selectedNode.getParent();
                object = selectedNode.getUserObject();
                return object instanceof NameObject ? selectedNode : null;
            }
        }
    }

}
