package com.fr.plugins.dsgroup;

import com.fr.design.data.datapane.TableDataTree;
import com.fr.design.gui.itree.refreshabletree.ExpandMutableTreeNode;
import com.fr.design.mainframe.dnd.ArrayTransferable;
import com.fr.general.NameObject;
import com.fr.plugins.dsgroup.GroupTableDataTree;

import javax.swing.*;
import javax.swing.tree.TreePath;
import java.awt.*;
import java.awt.dnd.*;
import java.util.*;
import java.util.List;

/**
 * Created by phetran_ye on 2018/8/20.
 */
public class GroupTableDataTreeDragSource extends DragSourceAdapter implements DragGestureListener {
    /*private Point orginPoint;
    private Point orginPointInScreen;*/
    private TreePath groupToMoveTo;
    private DragSource source=new DragSource();
    protected String[][] doubleArray;

    public GroupTableDataTreeDragSource(JTree tree, int actions) {
        this.source.createDefaultDragGestureRecognizer(tree,actions,this);
    }

    /*
      * Drag Gesture Handler
      */
    @Override
    public void dragGestureRecognized(DragGestureEvent dge) {
        groupToMoveTo =null;
        Component comp = dge.getComponent();
        if (comp instanceof TableDataTree) {
            List<String[]> names = new ArrayList();
            TableDataTree tree = (TableDataTree)comp;
            TreePath[] paths = tree.getSelectionPaths();
            if (paths == null) {
                return;
            }

            this.doubleArray = null;
            this.setnameArray(paths, names);
            this.source.startDrag(dge, DragSource.DefaultLinkDrop, new ArrayTransferable(this.doubleArray), this);
        }
    }

    protected void setnameArray(TreePath[] paths, List<String[]> stringList) {
        for (int i = 0; i < paths.length; i++) {
            if ((paths[i] == null) || (paths[i].getPathCount() <= 1)) {
                return;// We can't move the root node or an empty selection
            }
            ExpandMutableTreeNode segmentMutableTreeNode = (ExpandMutableTreeNode) paths[i].getLastPathComponent();
            Object userObj = segmentMutableTreeNode.getUserObject();
            List<String> tableAddress = new ArrayList<String>();
            String displayName;
            StringBuffer dsNameBuf = new StringBuffer();
            if (userObj instanceof NameObject) {
                continue;
            } else {
                if (!(userObj instanceof String)) {
                    continue;
                }
                displayName = (String) userObj;
                // james 读取表名
                //分组名不加
                while (!GroupTableDataTree.isGroupData((ExpandMutableTreeNode) segmentMutableTreeNode.getParent()) && segmentMutableTreeNode.getParent().getParent() != null) {
                    segmentMutableTreeNode = (ExpandMutableTreeNode) segmentMutableTreeNode.getParent();
                    ExpandMutableTreeNode datasheetExpandMutableTreeNode = segmentMutableTreeNode;
                    Object parentUserObj = datasheetExpandMutableTreeNode.getUserObject();
                    if (parentUserObj instanceof NameObject && !(((NameObject) parentUserObj).getObject() instanceof Integer)) {
                        NameObject nameObject = (NameObject) parentUserObj;
                        tableAddress.add(nameObject.getName());
                    }
                }
            }
            for (int j = tableAddress.size() - 1; j > -1; j--) {
                dsNameBuf.append(tableAddress.get(j));
                if (j != 0) {
                    dsNameBuf.append('_');
                }
            }
            String dsName;
            if (dsNameBuf.toString() != null) {
                dsName = dsNameBuf.toString();
            } else {
                return;
            }
            String[] attributes = {dsName, displayName};
            stringList.add(attributes);
            Object[] bo = stringList.toArray();
            doubleArray = new String[bo.length][];
            for (int io = 0; io < bo.length; io++) {
                if (bo[io] instanceof String[]) {
                    doubleArray[io] = (String[]) bo[io];
                }
            }
        }
    }

    /*@Override
    public void dragOver(DragSourceDragEvent dsde) {
        DragSourceContext dsc = dsde.getDragSourceContext();
        Component comp=dsc.getComponent();
        TableDataTree tree = (TableDataTree) comp;
        Point p=dsde.getLocation();
        if(null==orginPointInScreen){
            orginPointInScreen=p;
        }
        TreePath path = tree.getPathForLocation((int)(orginPoint.getX()+p.getX()-orginPointInScreen.getX()),
                (int)(orginPoint.getY()+p.getY()-orginPointInScreen.getY())) ;
        TreePath pt=tree.getPathForLocation((int)(p.getX()-tree.getBounds().getX()),(int)(p.getY()-tree.getBounds().getY()));
        if(pt!=null){
            System.out.println("++++"+pt.getLastPathComponent().toString());
        }

        if(null==path){
            if(null!= groupToMoveTo){
                tree.removeSelectionPath(groupToMoveTo);
                groupToMoveTo=null;
            }
        }else{
            //移入选择的分组是之前选中的节点之一不做任何处理
            TreePath[] paths=tree.getSelectionPaths();
            for(int i=0;i<paths.length;i++){
                if(paths[i].equals(path)){
                    return;
                }
            }
            if(
                    ((GroupTableDataTree) tree).isGroupData((ExpandMutableTreeNode) path.getLastPathComponent())
                    ){

                if(null==groupToMoveTo){
                    tree.addSelectionPath(path);
                    groupToMoveTo =path;
                }else if(!groupToMoveTo.equals(path)){
                    tree.addSelectionPath(path);
                    tree.removeSelectionPath(groupToMoveTo);
                    groupToMoveTo =path;
                }

            }else{
                if(null!= groupToMoveTo){
                    tree.removeSelectionPath(groupToMoveTo);
                    groupToMoveTo=null;
                }
            }

        }




    }*/

    @Override
    public void dragOver(DragSourceDragEvent dsde) {
        DragSourceContext dsc = dsde.getDragSourceContext();
        Component comp=dsc.getComponent();
        TableDataTree tree = (TableDataTree) comp;
        Point treePosition=comp.getLocationOnScreen();
        Point p=dsde.getLocation();
        TreePath path = tree.getPathForLocation((int)(p.getX()-treePosition.getX()),
                (int)(p.getY()-treePosition.getY())) ;
        if(null==path){
            if(null!= groupToMoveTo){
                tree.removeSelectionPath(groupToMoveTo);
                groupToMoveTo=null;
            }
        }else{
            //移入选择的分组是之前选中的节点之一不做任何处理
            TreePath[] paths=tree.getSelectionPaths();
            for(int i=0;i<paths.length;i++){
                if(paths[i].equals(path)){
                    return;
                }
            }
            if( (path.getLastPathComponent() instanceof ExpandMutableTreeNode) &&
                    GroupTableDataTree.isGroupData((ExpandMutableTreeNode) path.getLastPathComponent())
            ){

                if(null==groupToMoveTo){
                    tree.addSelectionPath(path);
                    groupToMoveTo =path;
                }else if(!groupToMoveTo.equals(path)){
                    tree.addSelectionPath(path);
                    tree.removeSelectionPath(groupToMoveTo);
                    groupToMoveTo =path;
                }

            }else{
                if(null!= groupToMoveTo){
                    tree.removeSelectionPath(groupToMoveTo);
                    groupToMoveTo=null;
                }
            }

        }

    }

    /*@Override
    public void dragDropEnd(DragSourceDropEvent dsde) {
        DragSourceContext dsc = dsde.getDragSourceContext();
        Component comp=dsc.getComponent();
        GroupTableDataTree tree = (GroupTableDataTree) comp;
        Point p=dsde.getLocation();
        if(null==orginPoint||null==orginPointInScreen){
            return;
        }
        TreePath path = tree.getPathForLocation((int)(orginPoint.getX()+p.getX()-orginPointInScreen.getX()),
                (int)(orginPoint.getY()+p.getY()-orginPointInScreen.getY())) ;
        System.out.println("++++end+"+p.toString());
        //没选中意味移到根路径下
        if(null==path) {
            tree.moveToRoot();
        }
        tree.getBounds()
        //移入的分组如果是选中的节点之一，不做处理,移入后该分组自动选择这里不判断了
        *//*TreePath[] paths=tree.getSelectionPaths();
        for(int i=0;i<paths.length;i++){
            if(paths[i].equals(path)) return;
        }*//*
        //将数据集或者分组移动到该分组下
        ExpandMutableTreeNode groupNode=(ExpandMutableTreeNode) groupToMoveTo.getLastPathComponent();
        if(null!= groupToMoveTo && groupToMoveTo.equals(path)&&tree.isGroupData(groupNode)){
            tree.moveToGroup(groupNode);
        }
        orginPoint=null;
        orginPointInScreen=null;
        groupToMoveTo =null;
    }*/

    @Override
    public void dragDropEnd(DragSourceDropEvent dsde) {
        DragSourceContext dsc = dsde.getDragSourceContext();
        Component comp=dsc.getComponent();
        GroupTableDataTree tree = (GroupTableDataTree) comp;
        Point treePosition=comp.getLocationOnScreen();
        Point p=dsde.getLocation();
        TreePath path = tree.getPathForLocation((int)(p.getX()-treePosition.getX()),
                (int)(p.getY()-treePosition.getY())) ;
        //没选中意味移到根路径下
        if(null==path) {
            tree.moveToRoot();
        }else{
            //将数据集或者分组移动到该分组下
            if(null!= groupToMoveTo && groupToMoveTo.equals(path)){
                ExpandMutableTreeNode groupNode=(ExpandMutableTreeNode) groupToMoveTo.getLastPathComponent();
                tree.moveToGroup(groupNode);
            }
            groupToMoveTo =null;
        }
    }

}
